-- WikNukem Forever
-- Copyright (C) 2009 Noé Falzon <firstname.lastname@aliceadsl.fr>

-- This program is  free software:  you can redistribute it and/or modify it
-- under  the terms  of the  GNU General Public License  as published by the
-- Free Software Foundation, version 3 of the License.
--
-- This program  is  distributed  in the hope  that it will  be useful,  but
-- WITHOUT  ANY WARRANTY;  without  even the implied  warranty of MERCHANTA-
-- BILITY  or  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
-- License for more details.
--
-- You should have received a copy of the  GNU General Public License  along
-- with this program. If not, see <http://www.gnu.org/licenses/>.

local EC = evol.curses

local diemessage = [[
__   __                _ _        
\ \ / /               | (_)       
 \ V /___  _   _    __| |_  ___   
  \ // _ \| | | |  / _` | |/ _ \  
  | | (_) | |_| | | (_| | |  __/_ 
  \_/\___/ \__,_|  \__,_|_|\___(_)
]]



die = {}

die.init = function()
	
end


local pattern = ".:;'~\"`´"

die.update = function(dt,fps,t)
	local W,H = evol.nw, evol.nh
	
	for i = 0,W-1 do
		for j = 0,H-1 do
			local amp = math.sin(2*math.pi/30*(i - 10/1000*t))
			amp = amp + math.sin(2*math.pi/50*(j - 15/1000*t))
			amp = amp + math.sin(2*math.pi/40*(i+j - 30/1000*t))
			amp = amp + math.sin(2*math.pi/45*(j-i - 20/1000*t))
					
			amp = amp/4 + 1
			amp = amp/2	-- should be 0..1 now
			
			EC.addch(pattern:sub(math.random(#pattern)),i,j)
			--EC.setcol(i,j,255,255*(amp-1)/2,0, 0,0,0)
			EC.setcol(i,j,0,255,255*amp, 0,0,0)
		end
	end
	
	blit(diemessage, W/2, H/2, true, {0,255,255},{0,math.random(0,255),0})
	
	EC.refresh()
end

die.keydown = function(key)
	
	evol.quit()
end
